/* libdf3 - info.c */

#include "df3_priv.h"


void df3_handle_info(df3Handle const * const df3, FILE *fp) {

  if (!df3  ||  !df3ValidHandle(df3))
    return;

  if (!fp)
    fp = stderr;

  int const w = 14;
  fprintf(fp, "%*s: %p\n", w, "handle", (void *)df3);
  fprintf(fp, "%*s: %s\n", w, "filename", df3->fname);
  fprintf(fp, "%*s: %s\n", w, "readonly",
          df3->readonly ? "yes" : "no");
  if (df3->ismapped) {
    mmFile * const p = df3->dp;
    fprintf(fp, "%*s: %s  (fd %d)\n%*s: %zu\n",
            w, "mapped", "yes", p->fd,
            w, "size", p->n);
  }
  else {
    size_t const sz = AXMUL(df3->axes) * df3->bpv + DF3_HEADERSIZE;
    fprintf(fp, "%*s: %s\n%*s: %zu\n",
            w, "mapped", "no",
            w, "size", sz);
  }
  fprintf(fp, "%*s: <%zu,%zu,%zu>\n", w, "axes",
          df3->axes.x, df3->axes.y, df3->axes.z);
  fprintf(fp, "%*s: %zu\n", w, "bpv", df3->bpv);
  fprintf(fp, "%*s: %04x\n", w, "checksum", df3->chcks);
  fprintf(fp, "%*s: %s (%d)\n", w, "status",
          df3_error_message(df3->ec), df3->ec);

  return;
}

/* ----------------------------------------------------------------- *
 *  this file is part of 'libdf3', part of the 'df3 tools' project.  *
 *  the content above is covered by the GPLv3+, see file COPYING.    *
 *  copyright (c) 2017 jr <creature.eternal@gmail.com>.              *
 *  all rights reserved.                                             *
 * ----------------------------------------------------------------- */
